#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <sysexits.h>

#include "segmento.h"
#include "intersec.h"
#include "avl.h"

#include <glib.h>

extern float colors[][3];

//-------------------------------------------------------------------
// Variaveis Globais
//-------------------------------------------------------------------
extern GCond*   cond;  /* Must be initialized somewhere */
extern GMutex*  mutex; /* Must be initialized somewhere */
extern int go;

abb *abb_eventpoints = NULL;

GList *segmentos    = NULL;
GList *pontos       = NULL;
GList *interseccoes = NULL;

point *pontoevento = NULL;


int verbose = 0;

static int n_intersec = 0;

extern int glarea_redraw();

void imprime (celula_pt r, int i) {
  /* Imprime a rvore com raiz r em formato de rvore */ 
  int j;
  segmento *a;
  
  if (r != NULL) { 
    a = (segmento *)r->info;
    imprime(r->esq, i+1); 
    for (j=0; j<i; j++)
      printf("   ");

    printf("(%d)\n", a->id);
    imprime(r->dir, i+1); 
  }
}


void imprimep (celula_pt r, int i) {
  /* Imprime a rvore com raiz r em formato de rvore */ 
  int j;
  point *p;
  

  if (r != NULL) { 
    p = (point  *)r->info;
    imprimep(r->esq, i+1); 
    for (j=0; j<i; j++)
      printf("   ");
    printf("(%1.1f %1.1f)\n", p->x, p->y);
    imprimep(r->dir, i+1); 
  }
}


GList *uniao (GList *a, GList *b)
{
  return g_list_concat (a, b);
}

void EncontreNovosEventos (abb *Q, GList **Tpontos, segmento *s, segmento *t, point *p)
{
  point *q;
  if ( (q = (point *)malloc(sizeof(point))) == NULL ) {
    fprintf (stderr, "Maloc error! %d,%s\n",__LINE__,__FILE__);
    exit (EX_OSERR);
  }
  
  /* como pode testar a comparacao entre um cara null ???? */
  //if (! (s && t)) return;
  
  if (s == NULL){
    printf(" S = NULL\n");
    return;
  }
  
  if (t == NULL){
    printf(" T = NULL\n");
    return;
  }
  if (s->id == t->id) return;
  

  // ----- COR ---------------
  s->cor = colors[ COR_DRAG ];
  t->cor = colors[ COR_DRAG ];
  // -------------------------
  
  
  if ( intersec (s, t, q) && 
       ((q->x > p->x) || ((q->x == p->x) && (q->y>p->y))) &&
       (! member(Q, (void *)q, point_func)) ) {
    // nao utilizar getponto para nao adicionar estes novos na lista de pontos.
    q->C = NULL;
    q->C = g_list_append (q->C, (gpointer)s);
    q->C = g_list_append (q->C, (gpointer)t);       
    q->D = NULL;
    q->E = NULL;
    
    interseccoes = g_list_append(interseccoes, (gpointer)q);
    glarea_redraw();
    
    printf (" *** Segmentos {(%2.2f,%2.2f),(%2.2f,%2.2f)}, {(%2.2f,%2.2f),(%2.2f,%2.2f)} se encontram em (%2.2f,%2.2f)!\n", 
	    s->esq->x, s->esq->y, s->dir->x, s->dir->y, t->esq->x, t->esq->y, t->dir->x, t->dir->y, q->x, q->y);
    
    insere_avl (Q, (void *)q, point_func);
  }
  //---- COR e REDRAW ----
  glarea_redraw();
  usleep(SLEEPTIME);  
  s->cor = colors[ COR_INTERSEC1 ];
  t->cor = colors[ COR_INTERSEC1 ];
  //----------------------

  n_intersec++;
}



void TrataPontoEvento (GList **Tpontos, point *p, abb *Q, abb *T)
{
  GList *U, *l;
  segmento *temp;
  segmento *se, *sd;
  se = NULL;
  sd = NULL;
  
  printf ("+ Tratando ponto evento (%2.2f,%2.2f)\n", p->x, p->y);

  p->C = g_list_first(p->C);
  p->D = g_list_first(p->D);
  p->E = g_list_first(p->E);
  
  
  //------------------------------------------------------------------
  /* <<< remova os segmentos em C de T */
  l = p->C;
  if (l == NULL) printf("  MESSAGE: p->C  == NULL\n");
  while (l != NULL) {
    printf ("  segmento C (%d): %p\n", ((segmento *)l->data)->id, (segmento *)l->data);
    delete_avl (T, (tipo_info)l->data, seg_func, p->x);
    l = g_list_next(l);
  }
  //------------------------------------------------------------------
  
  /* <<< remova os segmentos em D de T (deixa um 'temp' para ref.) */
  l = p->D;
  if (l == NULL) printf("  MESSAGE: p->D  == NULL\n");
  else{
    if (l->data == NULL)  printf("  ERR: l->data == NULL\n");
    
    temp = (segmento *)l->data;
    l = g_list_next(l);
    
    while (l != NULL) {
      delete_avl (T, l->data, seg_func, p->x);
      //--- SETA COR ---
      ((segmento *)l->data)->cor = colors[COR_NORMAL];
      //----------------
      l = g_list_next(l);
    }
    printf("  procurando BEFORE de temp (%d)\n",temp->id);
    se = before_avl (T, temp, seg_func, p->x);
    if (se != NULL)
      printf("  Achou... se = (%d)\n",se->id);
    printf("  procurando AFTER de temp (%d)\n",temp->id);
    sd = after_avl  (T, temp, seg_func, p->x);
    if (sd != NULL)
      printf("  Achou... sd = (%d)\n",sd->id);   
    
    //--- SETA COR ---
    temp->cor = colors[COR_NORMAL];
    //----------------
    
    delete_avl (T, temp, seg_func, p->x); 
  }
  
  //------------------------------------------------------------------

  /* >>> insira os segmentos de E  em T */
  l = p->E;
  if (l == NULL)  printf("  MESSAGE: p->E  == NULL\n");
  while (l != NULL) {
    insere_avl (T, (tipo_info)l->data, seg_func, p->x + (double)INF);
    //--- SETA COR ---
    ((segmento *)l->data)->cor = colors[COR_INTERSEC1];
    //----------------
    l = g_list_next(l);
  }
  
  //------------------------------------------------------------------

  /* remocao e reinsercao de segmentos em C inverte a ordem relativa */
  /* >>> insira os segmentos de C em T */
  l = p->C;
  while (l != NULL) {
    insere_avl (T, (tipo_info)l->data, seg_func, p->x + (double)INF);
    //--- SETA COR ---
    ((segmento *)l->data)->cor = colors[COR_INTERSEC1];
    //----------------
    l = g_list_next(l);
  }
  
  //------------------------------------------------------------------
  
  if ( (U = uniao (p->E, p->C)) == NULL ) {
    
     printf("  p->E && p->C == NULL (temp null:  %d )\n", temp == NULL);
    // printf ("  se %p,  sd %p\n",  se,  sd);  
    if (se && sd)
      EncontreNovosEventos (Q, Tpontos, se, sd, p);
    
  }
  else {
    segmento *min, *max, *s;
    
    printf("  p->E && p->C != NULL!\n");

    /* Encontra o mais a esquerda/direita
       utilizando os coeficientes angulares */
    l = U;
    min = (segmento *)l->data;
    max = (segmento *)l->data;
    
    while ( (l = g_list_next(l)) != NULL ) {
      s = (segmento *)l->data;
      if (s->denom == 0.0) { 
	if (s->a > 0) min = s;
	else if (s->a < 0) max = s;
      }
      else {
	if (min->denom && (s->a/s->denom > min->a/min->denom)) min = s;
	else if (max->denom && (s->a/s->denom < max->a/max->denom)) max = s;
      }
      
    }
    if ((min == NULL) || (max == NULL))
      printf("  ERR EII TEM NULLLL ( min ou max )!\n");
    
    printf("  procurando BEFORE de min (%d)\n",min->id);
    
    
    se = before_avl (T, min, seg_func, p->x + (double)INF);
    //   if (se != NULL)   printf("  Achou... se = (%d)\n",se->id);
  
    
    printf("  procurando AFTER de max (%d)\n",max->id);
    sd = after_avl (T, max, seg_func, p->x + (double)INF);
    //  if (sd != NULL)  printf("  Achou... sd = (%d)\n",sd->id);
    
    EncontreNovosEventos (Q, Tpontos, se, min, p);
    EncontreNovosEventos (Q, Tpontos, max, sd, p);
   
    
    printf("OK\n");
  }

  printf (" Sweepline structure:\n");
  imprime (T->raiz, 0);

  printf ("\n");
}



void smart(GList **Tpontos)
{
  GList *p;
  celula_pt c;
  abb T, Q;
  
  printf ("esperto (sweepline algorithm) ... *\n\n");

  n_intersec = 0;
  
  
  /* monta a estrutura de varredura */
  inicializa_abb (&T);
  
  /* monta a fila de pontos eventos */
  inicializa_abb (&Q);

  p = g_list_first(*Tpontos);
  while (p != NULL) {
    insere_avl (&Q, (void *)p->data, point_func);
    p = g_list_next(p);
  }
  
  abb_eventpoints = &Q;
  
  while (Q.raiz != NULL) {
    printf ("Pontos Eventos:\n");
    imprimep (Q.raiz, 0);
    
    c = minimo (Q.raiz);
    delete_cel_avl (&Q, c);
    
    /*
    //-------- WAIT ------------
    g_mutex_lock (mutex);
    printf("MUTEX LOCKED\n");
    while (!go){
      printf("WAITING COND\n");
      g_cond_wait (cond, mutex);
    }
    go = FALSE;
    g_mutex_unlock (mutex);
    printf("MUTEX UNLOCKED\n");
    //---------------------------
    */
    pontoevento = (point *)c->info;

    glarea_redraw();
    TrataPontoEvento (Tpontos, pontoevento, &Q, &T);
    glarea_redraw();
    usleep(SLEEPTIME);  
  }
  
  pontoevento = NULL;
  abb_eventpoints = NULL;
  
  glarea_redraw();

  printf("Numero de interseccoes calculadas: %d\n",n_intersec);
}


  

/* 
   resolve o problema de interseccao de segmentos com um algoritmo
   ingenuo (resolve em O(n2) 
*/
void ingenuo (GList **segs)
{
  point p;
  segmento *a, *b;
  int i, j;
  GList *t, *r;
  
  t = g_list_first(*segs);
  
  i = j = 1;
  n_intersec = 0;
  
  while (t != NULL) {
    
    r = g_list_next(t);
    a = (segmento *)t->data;

    a->cor = colors[COR_INTERSEC1];
    

    while (r != NULL) {
      b = (segmento *)r->data;

      b->cor = colors[COR_INTERSEC2];
      
      // contador;
      n_intersec++;
      
      if ( intersec (a, b, &p)) {
	 point *p_intersec;
	 printf ("- Segmentos %d e %d se intersectam em (%2.2f,%2.2f)\n", i, j, p.x, p.y);	
	
	 p_intersec = (point *)malloc(sizeof(point));
	 p_intersec->x = p.x;
	 p_intersec->y = p.y;
	 interseccoes = g_list_append(interseccoes, (gpointer)p_intersec);
      }

      
      glarea_redraw();
      usleep(0.9*SLEEPTIME);
     
      r = g_list_next(r);
      j++;
      b->cor = colors[COR_NORMAL];
    }
    a->cor = colors[COR_NORMAL];
    
    t = g_list_next(t);
    i++;
  }

  printf("Numero de interseccoes calculadas: %d\n",n_intersec);
}



//---- Funcoes para gravar e ler segmentos de arquivo

int readfile (char *fname)
{
  FILE *fp;
  int n = 0, l;
  char *path;
  
  float a, b, c, d;

  printf("Tentando ler arquivo : %s\n", fname);

  if (! strcmp(fname,"")) { 
    fprintf (stderr, "Tentando ler diretorio! '%s'\n", DIR);
    return 0;
  }

  l = 1+strlen(fname)+strlen(DIR);
  path = malloc(l+2);
  snprintf (path, l+1, "%s/%s", DIR, fname);
  
  if ( (fp = fopen (path, "r")) == NULL ) {
    fprintf (stderr, "Erro ao ler arquivo: '%s'\n", fname);
    return (EX_OSERR);
  }
  
  
  while (!feof(fp)){
    fscanf (fp, "%f %f %f %f", &a, &b, &c, &d);

    addSegment(a, b, c, d);
    
    n++;
  }
  
  printf("Leu: %d segmentos\n", n);
  fclose (fp);
  return n;
}


int savefile (char *fname)
{
  FILE *fp;
  int n = 0, l;
  char *path;
  GList *segs = g_list_first(segmentos);
 
  printf("Tentando gravar arquivo : %s\n", fname);

  if (! strcmp(fname,"")) { 
    fprintf (stderr, "Tentando escrever diretorio! '%s'\n", DIR);
    return 0;
  }

  l = 1+strlen(fname)+strlen(DIR);
  path = malloc(l+2);
  snprintf (path, l+1, "%s/%s", DIR, fname);
  
  if ( (fp = fopen (path, "w")) == NULL ) {
    fprintf (stderr, "Erro ao criar arquivo: '%s'\n", fname);
    return 0;//exit (EX_OSERR);
  }
  
  while (segs != NULL){
    segmento *s = segs->data;
    
    fprintf(fp, "%d %d %d %d\n", (int)s->esq->x, (int)s->esq->y, (int)s->dir->x, (int)s->dir->y);
    segs = g_list_next(segs);
    n++;
  }
  
  printf("Gravou: %d segmentos\n", n);
  fclose (fp);
  return n;
}












