#ifndef __SEGMENTO_H
#define __SEGMENTO_H

#include <glib.h>

#define TAM_PONTO 5

#define COR_DRAG         0
#define COR_NORMAL       2
#define COR_IN_SWEEPLINE 4
#define COR_INTERSEC1    5
#define COR_INTERSEC2    6


#define INGENUO 0
#define SMART   1  



/* o que eh logo apos */
#define INF 0.000001

typedef struct {
  double x, y;

  GList *E,       /* subconjunto dos segentos cuja extremidade esquerda eh p */
    *C,           /* subconjunto dos segmentos encontrados em T que possuem extremidade direita em p */
    *D;           /* subconjunto dos segmentos encontrados em T que possuem p em seu interior */
} point;



typedef struct {
  int id;
  
  float *cor;
  point *esq, *dir;
  
  double a, b, denom;    /* y = (ax + b)/denom */
} segmento;



point* getponto (GList **pontos, double x, double y);
int intersec (segmento *a, segmento *b, point *p);

int point_func (point *a, point *b);
int seg_func (segmento *a, segmento *b, va_list *ptr);

int addSegment (double x1, double y1, double x2, double y2);
int delLastSegment ();


void reset();



#endif











