/* window.h */

#ifndef __WINDOW_H__
#define __WINDOW_H__

#include <stdio.h>
#include <gtk/gtk.h>


void keybind( GtkWidget *widget, char *keys );


GtkObject *new_adjustment(float value, float low, float upper,
			  void *callback, gpointer callback_data);
GtkWidget *add_status_bar(GtkWidget *parent);


/* Auxiliary functions */
void      add_separator( GtkWidget *parent );

GtkWidget *add_hbox( GtkWidget *parent, int homog, int spacing );

GtkWidget *add_vbox( GtkWidget *parent, int homog, int spacing );

GtkWidget *add_hscale( GtkWidget *parent_w, GtkAdjustment *adjustment );

GtkWidget *add_vscale( GtkWidget *parent_w, GtkAdjustment *adjustment );


GtkWidget *create_frame(GtkWidget *parent, GtkWidget *conteudo, char *nome);
GtkWidget *new_frame(GtkWidget *conteudo, char *nome);
GtkWidget *add_frame(GtkWidget *conteudo, const char *nome);


GtkWidget *add_label( GtkWidget *parent_w, const char *label_text );

GtkWidget *new_button(GtkWidget *box_parent, const char *nome, void *funcao,
		      gpointer data);

GtkWidget *new_check_button(GtkWidget *box_parent, char *nome, gint inicio,
			    void *funcao, gpointer data);

GtkWidget *new_radio_button(GtkWidget *parent, GtkWidget *other, gchar *nome, 
			    gint status, void *funcao, gpointer data);


GtkWidget *new_entry(GtkWidget *box,  gchar *prenome, gchar *posnome,  gchar *evento, 
		     void *funcao, gpointer data);

GtkWidget *new_mostrador(GtkWidget *box,  gchar *nome, gchar *text);


GtkWidget *new_menu_bar(GtkWidget *parent_box);
GtkWidget *new_menu(GtkWidget *menu_bar, char *name);
GtkWidget *new_menu_item(GtkWidget *parent_menu, char *label, void *funcao, 
			 gpointer data);
GtkWidget *new_check_menu_item( GtkWidget *menu, const char *label, 
				int init_state, void *funcao, gpointer data );
void       new_menu_separator( GtkWidget *parent );
GtkWidget *option_menu_item( const char *label, void *callback, void *callback_data );

GtkWidget *add_option_menu( GtkWidget *widget );



GtkWidget *new_text_window(const char *label);
GtkWidget *new_colorse_window (void *callback_ok);
GtkWidget *new_filesel_window(const char *title, const char *init_filename,
			      int show_fileops, void *callback_ok, 
			      gpointer data_ok );


GtkWidget *new_ok_cancel_dialog(GtkWidget *conteudo,  const char *title,  
				void *callback, gpointer data );


void  entry_set_float (GtkWidget *entry, gfloat v, char *s);
void  entry_set_long  (GtkWidget *entry, long v);
void  label_set_float (GtkWidget *label, gfloat v, char *s);
void  label_set_long  (GtkWidget *label, long v);
char *entry_get_text  (GtkWidget *widget);
float entry_get_float (GtkWidget *widget);


GtkWidget *add_gl_area( GtkWidget *parent );










#endif /* __WINDOW_H__ */



















